using System;
using System.Security.Cryptography;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Web.Services.Protocols;

namespace webSvcForFimaCsharp
{
	internal class UsdList
	{
		public bool debug;

		private string USER_HANDLE;

		public int SID;

		private USD_WebService ws;

		public UsdList()
		{
		}

		public static string encPass()
		{
			string base64String = "";
			string upper = "";
			int num = 0;
			try
			{
				X509Certificate2 x509Certificate2 = null;
				X509Store x509Store = new X509Store(StoreName.My, StoreLocation.LocalMachine);
				x509Store.Open(OpenFlags.ReadOnly);
				X509Certificate2Enumerator enumerator = x509Store.Certificates.GetEnumerator();
				while (enumerator.MoveNext())
				{
					X509Certificate2 current = enumerator.Current;
					if (current.FriendlyName.ToLower().Contains("servicedesk"))
					{
						x509Certificate2 = current;
						upper = current.FriendlyName.ToLower().Replace("servicedesk ", "").ToUpper();
						num++;
					}
				}
				if ((num == 0 ? true : x509Certificate2 == null))
				{
					throw new Exception("Servicedesk certificate not found.");
				}
				if (num > 1)
				{
					throw new Exception("More than one Servicedesk certificate found.");
				}
				SHA1 sHA1 = SHA1.Create();
				byte[] numArray = sHA1.ComputeHash(Encoding.Default.GetBytes(upper));
				RSACryptoServiceProvider privateKey = (RSACryptoServiceProvider)x509Certificate2.PrivateKey;
				base64String = Convert.ToBase64String(privateKey.SignHash(numArray, "SHA1"));
			}
			catch (Exception exception)
			{
				throw exception;
			}
			return base64String;
		}

		public static string getCertName()
		{
			string upper = "";
			int num = 0;
			try
			{
				X509Store x509Store = new X509Store(StoreName.My, StoreLocation.LocalMachine);
				x509Store.Open(OpenFlags.ReadOnly);
				X509Certificate2Enumerator enumerator = x509Store.Certificates.GetEnumerator();
				while (enumerator.MoveNext())
				{
					X509Certificate2 current = enumerator.Current;
					if (current.FriendlyName.ToLower().Contains("servicedesk"))
					{
						upper = current.FriendlyName.ToLower().Replace("servicedesk ", "").ToUpper();
						num++;
					}
				}
				if (num == 0)
				{
					throw new Exception("Servicedesk certificate not found.");
				}
				if (num > 1)
				{
					throw new Exception("More than one Servicedesk certificate found.");
				}
			}
			catch (Exception exception)
			{
				throw exception;
			}
			return upper;
		}

		public void ListIncs()
		{
			string[] strArrays = new string[] { "summary", "description", "category", "ref_num" };
			string str = this.ws.doSelect(this.SID, "cr", "active=1", -1, strArrays);
			Console.WriteLine(str);
		}

		public void Login()
		{
			this.ws = new USD_WebService()
			{
				Url = "http://sd125:8080/axis/services/USD_R11_WebService?WSDL"
			};
			string str = "servicedesk";
			string str1 = "Qwerty123";
			try
			{
				this.SID = this.ws.login(str, str1);
				if (this.SID > 0)
				{
					this.USER_HANDLE = this.ws.getHandleForUserid(this.SID, str);
					if (this.debug)
					{
						Console.WriteLine("Login success with SID: {0}, User Handle: {1}", this.SID.ToString(), this.USER_HANDLE);
					}
				}
				else
				{
					Console.WriteLine("Login failed!");
				}
			}
			catch (SoapException soapException)
			{
				Console.WriteLine(soapException.Message);
			}
			catch (Exception exception)
			{
				Console.WriteLine(exception.Message);
			}
		}

		public void LoginServiceManaged()
		{
			this.ws = new USD_WebService()
			{
				Url = "http://sd125:8080/axis/services/USD_R11_WebService?WSDL"
			};
			string str = "emp1";
			try
			{
				this.SID = Convert.ToInt32(this.ws.loginServiceManaged(UsdList.getCertName(), UsdList.encPass()));
				if (this.SID > 0)
				{
					this.USER_HANDLE = this.ws.getHandleForUserid(this.SID, str);
					if (this.debug)
					{
						Console.WriteLine("Login success with SID: {0}, User Handle: {1}", this.SID.ToString(), this.USER_HANDLE);
					}
				}
				else
				{
					Console.WriteLine("Login failed!");
				}
			}
			catch (SoapException soapException)
			{
				Console.WriteLine(soapException.Message);
			}
			catch (Exception exception)
			{
				Console.WriteLine(exception.Message);
			}
		}

		public void Logout()
		{
			this.ws.logout(this.SID);
		}
	}
}